Scala Standard Library2.13.5 < Back


# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.collection.parallel` - Parallel collections (scala-parallel-collections.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package collection
  Definition Classes
    scala
-  package mutable
  Definition Classes
    collection
- AbstractBuffer
- AbstractIterable
- AbstractMap
- AbstractSeq
- AbstractSet
- AnyRefMap
- ArrayBuffer
- ArrayBufferView
- ArrayBuilder
- ArrayDeque
- ArrayDequeOps
- ArraySeq
- BitSet
- Buffer
- Builder
- Clearable
- Cloneable
- CollisionProofHashMap
- Growable
- GrowableBuilder
- HashMap
- HashSet
- ImmutableBuilder
- IndexedBuffer
- IndexedSeq
- IndexedSeqOps
- Iterable
- LinkedHashMap
- LinkedHashSet
- ListBuffer
- ListMap
- LongMap
- Map
- MapOps
- MultiMap
- OpenHashMap
- PriorityQueue
- Queue
- ReusableBuilder
- Seq
- SeqMap
- SeqOps
- Set
- SetOps
- Shrinkable
- SortedMap
- SortedMapOps
- SortedSet
- SortedSetOps
- Stack
- StringBuilder
- TreeMap
- TreeSet
- UnrolledBuffer
- WeakHashMap

o

scala.collection.mutable

# ArrayBuffer

###
Companion class ArrayBuffer

#### object ArrayBuffer extends StrictOptimizedSeqFactory[ArrayBuffer]

Factory object for the `ArrayBuffer` class.

This object provides a set of operations to create `mutable.ArrayBuffer` values.

Annotations
  @SerialVersionUID()
Source
  ArrayBuffer.scala

Linear Supertypes
StrictOptimizedSeqFactory[ArrayBuffer], SeqFactory[ArrayBuffer], IterableFactory[ArrayBuffer], java.io.Serializable, AnyRef, Any

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ArrayBuffer
2. StrictOptimizedSeqFactory
3. SeqFactory
4. IterableFactory
5. Serializable
6. AnyRef
7. Any

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##: Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
4.  final val DefaultInitialSize: Int(16)
5.  def apply[A](elems: A*): ArrayBuffer[A]

   Creates a array buffer with the specified elements.

   Creates a array buffer with the specified elements.

   A

     the type of the array buffer's elements

   elems

     the elements of the created array buffer

   returns

     a new array buffer with elements `elems`

   Definition Classes
     IterableFactory
6.  final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7.  def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
   Note

     not specified by SLS as a member of AnyRef

8.  def concat[A](xss: collection.Iterable[A]*): ArrayBuffer[A]

   Concatenates all argument collections into a single array buffer.

   Concatenates all argument collections into a single array buffer.

   xss

     the collections that are to be concatenated.

   returns

     the concatenation of all the collections.

   Definition Classes
     StrictOptimizedSeqFactory → IterableFactory
9.  def empty[A]: ArrayBuffer[A]

   An empty collection

   An empty collection

   A

     the type of the array buffer's elements

   Definition Classes
     ArrayBuffer → IterableFactory
10.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
11.  def equals(arg0: AnyRef): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any
12.  def fill[A](n: Int)(elem: => A): ArrayBuffer[A]

    Produces a array buffer containing the results of some element computation a number of times.

    Produces a array buffer containing the results of some element computation a number of times.

    n

      the number of elements contained in the array buffer.

    elem

      the element computation

    returns

      A array buffer that contains the results of `n` evaluations of `elem`.

    Definition Classes
      StrictOptimizedSeqFactory → IterableFactory
13.  def fill[A](n1: Int, n2: Int, n3: Int, n4: Int, n5: Int)(elem: => A): ArrayBuffer[ArrayBuffer[ArrayBuffer[ArrayBuffer[ArrayBuffer[A]]]]]

    Produces a five-dimensional array buffer containing the results of some element computation a number of times.

    Produces a five-dimensional array buffer containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    n4

      the number of elements in the 4th dimension

    n5

      the number of elements in the 5th dimension

    elem

      the element computation

    returns

      A array buffer that contains the results of `n1 x n2 x n3 x n4 x n5` evaluations of `elem`.

    Definition Classes
      IterableFactory
14.  def fill[A](n1: Int, n2: Int, n3: Int, n4: Int)(elem: => A): ArrayBuffer[ArrayBuffer[ArrayBuffer[ArrayBuffer[A]]]]

    Produces a four-dimensional array buffer containing the results of some element computation a number of times.

    Produces a four-dimensional array buffer containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    n4

      the number of elements in the 4th dimension

    elem

      the element computation

    returns

      A array buffer that contains the results of `n1 x n2 x n3 x n4` evaluations of `elem`.

    Definition Classes
      IterableFactory
15.  def fill[A](n1: Int, n2: Int, n3: Int)(elem: => A): ArrayBuffer[ArrayBuffer[ArrayBuffer[A]]]

    Produces a three-dimensional array buffer containing the results of some element computation a number of times.

    Produces a three-dimensional array buffer containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    elem

      the element computation

    returns

      A array buffer that contains the results of `n1 x n2 x n3` evaluations of `elem`.

    Definition Classes
      IterableFactory
16.  def fill[A](n1: Int, n2: Int)(elem: => A): ArrayBuffer[ArrayBuffer[A]]

    Produces a two-dimensional array buffer containing the results of some element computation a number of times.

    Produces a two-dimensional array buffer containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    elem

      the element computation

    returns

      A array buffer that contains the results of `n1 x n2` evaluations of `elem`.

    Definition Classes
      IterableFactory
17.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
    Note

      not specified by SLS as a member of AnyRef

18.  def from[B](coll: IterableOnce[B]): ArrayBuffer[B]

    Creates a target array buffer from an existing source collection

    Creates a target array buffer from an existing source collection

    returns

      a new array buffer with the elements of `source`

    Definition Classes
      ArrayBuffer → IterableFactory
19.  final def getClass(): Class[_ <: AnyRef]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
20.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
21.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
22.  implicit def iterableFactory[A]: Factory[A, ArrayBuffer[A]]
    Definition Classes
      IterableFactory
23.  def iterate[A](start: A, len: Int)(f: (A) => A): ArrayBuffer[A]

    Produces a array buffer containing repeated applications of a function to a start value.

    Produces a array buffer containing repeated applications of a function to a start value.

    start

      the start value of the array buffer

    len

      the number of elements contained in the array buffer

    f

      the function that's repeatedly applied

    returns

      a array buffer with `len` values in the sequence `start, f(start), f(f(start)), ...`

    Definition Classes
      IterableFactory
24.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
25.  def newBuilder[A]: Builder[A, ArrayBuffer[A]]

    A

      the type of the array buffer’s elements

    returns

      A builder for `mutable.ArrayBuffer` objects.

    Definition Classes
      ArrayBuffer → IterableFactory
26.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

27.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

28.  def range[A](start: A, end: A, step: A)(implicit arg0: Integral[A]): ArrayBuffer[A]

    Produces a array buffer containing equally spaced values in some integer interval.

    Produces a array buffer containing equally spaced values in some integer interval.

    start

      the start value of the array buffer

    end

      the end value of the array buffer (the first value NOT contained)

    step

      the difference between successive elements of the array buffer (must be positive or negative)

    returns

      a array buffer with values `start, start + step, ...` up to, but excluding `end`

    Definition Classes
      IterableFactory
29.  def range[A](start: A, end: A)(implicit arg0: Integral[A]): ArrayBuffer[A]

    Produces a array buffer containing a sequence of increasing of integers.

    Produces a array buffer containing a sequence of increasing of integers.

    start

      the first element of the array buffer

    end

      the end value of the array buffer (the first value NOT contained)

    returns

      a array buffer with values `start, start + 1, ..., end - 1`

    Definition Classes
      IterableFactory
30.  final def synchronized[T0](arg0: => T0): T0

    Executes the code in `body` with an exclusive lock on `this`.

    Executes the code in `body` with an exclusive lock on `this`.

    returns

      the result of `body`

    Definition Classes
      AnyRef
31.  def tabulate[A](n: Int)(f: (Int) => A): ArrayBuffer[A]

    Produces a array buffer containing values of a given function over a range of integer values starting from 0.

    Produces a array buffer containing values of a given function over a range of integer values starting from 0.

    n

      The number of elements in the array buffer

    f

      The function computing element values

    returns

      A array buffer consisting of elements `f(0), ..., f(n -1)`

    Definition Classes
      StrictOptimizedSeqFactory → IterableFactory
32.  def tabulate[A](n1: Int, n2: Int, n3: Int, n4: Int, n5: Int)(f: (Int, Int, Int, Int, Int) => A): ArrayBuffer[ArrayBuffer[ArrayBuffer[ArrayBuffer[ArrayBuffer[A]]]]]

    Produces a five-dimensional array buffer containing values of a given function over ranges of integer values starting from 0.

    Produces a five-dimensional array buffer containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    n4

      the number of elements in the 4th dimension

    n5

      the number of elements in the 5th dimension

    f

      The function computing element values

    returns

      A array buffer consisting of elements `f(i1, i2, i3, i4, i5)` for `0 <= i1 < n1`, `0 <= i2 < n2`, `0 <= i3 < n3`, `0 <= i4 < n4`, and `0 <= i5 < n5`.

    Definition Classes
      IterableFactory
33.  def tabulate[A](n1: Int, n2: Int, n3: Int, n4: Int)(f: (Int, Int, Int, Int) => A): ArrayBuffer[ArrayBuffer[ArrayBuffer[ArrayBuffer[A]]]]

    Produces a four-dimensional array buffer containing values of a given function over ranges of integer values starting from 0.

    Produces a four-dimensional array buffer containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    n4

      the number of elements in the 4th dimension

    f

      The function computing element values

    returns

      A array buffer consisting of elements `f(i1, i2, i3, i4)` for `0 <= i1 < n1`, `0 <= i2 < n2`, `0 <= i3 < n3`, and `0 <= i4 < n4`.

    Definition Classes
      IterableFactory
34.  def tabulate[A](n1: Int, n2: Int, n3: Int)(f: (Int, Int, Int) => A): ArrayBuffer[ArrayBuffer[ArrayBuffer[A]]]

    Produces a three-dimensional array buffer containing values of a given function over ranges of integer values starting from 0.

    Produces a three-dimensional array buffer containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    f

      The function computing element values

    returns

      A array buffer consisting of elements `f(i1, i2, i3)` for `0 <= i1 < n1`, `0 <= i2 < n2`, and `0 <= i3 < n3`.

    Definition Classes
      IterableFactory
35.  def tabulate[A](n1: Int, n2: Int)(f: (Int, Int) => A): ArrayBuffer[ArrayBuffer[A]]

    Produces a two-dimensional array buffer containing values of a given function over ranges of integer values starting from 0.

    Produces a two-dimensional array buffer containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    f

      The function computing element values

    returns

      A array buffer consisting of elements `f(i1, i2)` for `0 <= i1 < n1` and `0 <= i2 < n2`.

    Definition Classes
      IterableFactory
36.  def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any
37.  final def unapplySeq[A](x: ArrayBuffer[A]): UnapplySeqWrapper[A]
    Definition Classes
      SeqFactory
38.  def unfold[A, S](init: S)(f: (S) => Option[(A, S)]): ArrayBuffer[A]

    Produces a array buffer that uses a function `f` to produce elements of type `A` and update an internal state of type `S`.

    Produces a array buffer that uses a function `f` to produce elements of type `A` and update an internal state of type `S`.

    A

      Type of the elements

    S

      Type of the internal state

    init

      State initial value

    f

      Computes the next element (or returns `None` to signal the end of the collection)

    returns

      a array buffer that produces elements using `f` until `f` returns `None`

    Definition Classes
      IterableFactory
39.  final def wait(): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--.

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--.

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
    Note

      not specified by SLS as a member of AnyRef

40.  final def wait(arg0: Long, arg1: Int): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
    Note

      not specified by SLS as a member of AnyRef

41.  final def wait(arg0: Long): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-.

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-.

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
    Note

      not specified by SLS as a member of AnyRef

### Inherited from StrictOptimizedSeqFactory[ArrayBuffer]

### Inherited from SeqFactory[ArrayBuffer]

### Inherited from IterableFactory[ArrayBuffer]

### Inherited from java.io.Serializable

### Inherited from AnyRef

### Inherited from Any

### Ungrouped